SystemOrganization addCategory: #'Mason-Metacello'!

MDProduct subclass: #MDMetacelloProduct
	instanceVariableNames: 'project version required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Metacello'!

!MDMetacelloProduct methodsFor: 'specifying' stamp: 'cwp 11/10/2009 00:01'!
packages
	| loader theProject repository packages |
	loader := MetacelloNullRecordingMCSpecLoader new.
	theProject := self theProject.
	theProject loader: loader.
	theProject load: self required.
	repository := loader loadedRepositories first.
	packages := loader packages.
	packages do: [:ea | ea repository ifNil: [ea repository: repository]].
	^ packages! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
project
	^ project! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
project: anObject
	project := anObject! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:57'!
required
	^ required ifNil: [#('DEFAULT')]! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
required: anObject
	required := anObject! !

!MDMetacelloProduct methodsFor: 'specifying' stamp: 'cwp 11/10/2009 00:12'!
specifyOn: targets 
	| repositories |
	repositories := Dictionary new.
	self packages do: 
		[ :ea | 
		| repository repoSpec |
		repoSpec := ea repository.
		repository := repositories 
			detect: [ :repo | repo name = repoSpec name ]
			ifNone: 
				[ repositories 
					at: repoSpec name
					put: repoSpec createRepository ].
		targets version
			name: ea file, '.mcz'
			repository: repository]! !

!MDMetacelloProduct methodsFor: 'specifying' stamp: 'cwp 11/8/2009 19:21'!
theProject
	^ version
		ifNil: [project latestVersion]
		ifNotNil: [project version: version]! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
version
	^ version! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
version: anObject
	version := anObject! !
